% This is samplepaper.tex, a sample chapter demonstrating the
% LLNCS macro package for Springer Computer Science proceedings;
% Version 2.20 of 2017/10/04
%
% Options for packages loaded elsewhere
\PassOptionsToPackage{unicode}{hyperref}
\PassOptionsToPackage{hyphens}{url}

\documentclass[runningheads]{llncs}
\usepackage{amsmath, amsthm, amssymb, amsfonts}
\usepackage{hyperref}
\usepackage{graphicx}
\usepackage[ruled,vlined]{algorithm2e}
\usepackage{dsfont}
%
\DeclareMathOperator*{\argmin}{argmin}
\DeclareMathOperator*{\argmax}{argmax}

\begin{document}
\title{Investigation of the successor representation for neuro-computational
models of the hippocampus\thanks{I would like to thank Julien Vitay for the supervision of this work and
the Artificial Intelligence team of Chemnitz University for its warm
welcome.}}
  \titlerunning{SR for hippocampus models}

\author{
  Romain Ferrand
  \inst{
            2
        }
    \and
  Julien Vitay
  \inst{
            1
        }
    }
  \authorrunning{R. Ferrand, J. Vitay}

\institute{
      Faculty of Computer Science,Chemnitz University of Technology, Straße
    der Nationen 62, D-09107 Chemnitz, Germany
    \email{dekanat@informatik.tu-chemnitz.de}
    \url{https://www.tu-chemnitz.de/informatik/KI/index.php.en}
    \and
      École normale supérieure de Rennes, Campus de Ker Lann, Avenue Robert
    Schuman, 35170 BRUZ, France
    \email{david.pichardie@ens-rennes.fr}
    \url{http://www.ens-rennes.fr}
      }

\maketitle

\begin{abstract}
Successor representations (SR) is a novel trade-off between model-free
and model-based reinforcement learning (RL) which has been used to
explain several neurobiological findings, including dopaminergic reward
prediction errors. \cite{stachenfeld2017hippocampus} showed that it can
be used to explain the formation of place and grid cells in the
hippocampal formation. This paper re-implement this model and provide a
multi-timescale model of the \emph{SR} along with a neurobiologically
feasible actor-critic framework. Finally we study the properties of
these models in the context of Tolman's maze, goal directed experiments
and its capacity of automatically find sub-goal with clustering.
\keywords{
  Reinforcement learning\and
  Goal directed decision\and
  Place fields\and
  Hippocampus\and
  Successor representation}
\end{abstract}

\section*{Introduction}
\addcontentsline{toc}{section}{Introduction}

The hippocampus is a brain region particularly known for its importance
in spatial representation and spatial memory.
\cite{andersen2006hippocampus} These cognitive functions are expressed
through a commonly accepted theory called: \emph{the cognitive map
theory of the hippocampus} \cite{o1978hippocampus}.

This theory suggests hippocampus builds an \emph{allocentric} or an
absolute representation of the local environment, uses this
representation for navigation purposes and maintains a spatial memory
system that is independent from other memory systems of the brain and
obeys to specific learning rules. This theory also argues for the
responsibility of the hippocampus on the storage and uses of episodic
information and even linguistic memory, when it comes to human.
\cite{andersen2006hippocampus}

\subsection*{Place-cells and place-fields}
\addcontentsline{toc}{subsection}{Place-cells and place-fields}

This mapping system implies the existence of a neural substrates which
will code for it: the \emph{place-cells}. In the context of free-moving
animal, \emph{place-cells} are neurons which firing rate increase from
low to high frequency when the animal get closer to a specific location
in space.

A \emph{place-cell} is commonly said to code for a specific location in
space, and the region of space where the cell is activated is called the
\emph{place-field}. For the sake of completeness we also introduce
another neural substrate which also code for spatial representation
\emph{Grid-cells}.

\emph{Grid-cells} are located inside the \emph{entorhinal cortex} which
is in close interaction with the \emph{hippocampus}. A grid cell, acts
similarly to a place-cell except that a unique grid-cell have multiples
activation point in space. Thanks to these activation points grid-cells
create a triangular paving of the local environment. Grid-cells
activation field are locally invariant in size, orientation and spacing,
these properties are presumed to allow distance estimation
\cite{hafting2005microstructure}. Grid-cells, contrary to place-cells
can also be left unchanged when the environment is subject to slight
changes. \cite{fyhn2007hippocampal}

\subsection*{Place-cells and the goal encoding problem}
\addcontentsline{toc}{subsection}{Place-cells and the goal encoding
problem}

Representation and spatial navigation is one of the major challenges for
animal survival. Indeed, it is this representation of space that allows
it to identify dangers, food or sexual partners and to use these
information to plan its actions. According to the theory ``hippocampus
as cognitive map'', \emph{place-cells} are activated for and when the
animal is located in a specific point in space. Because of a goal is by
definition a position which is not yet reached this representation does
not allow to encode goal location. \cite{POUCET201751} suggest if the
goal are encoded by \emph{place-cells} so the \emph{cognitive map
theory} leads to an ambiguity about whether the cell is activated
according to a goal or according to animal position.

However, experimental evidences have shown the importance of
\emph{place-cells} for goal encoding, and in return \emph{place-cells}
are shaped with respect to the path towards the goal (i.e,
\emph{place-cells} firing rate is behaviorally dependent)
\cite{POUCET201751}. These different observations brought to the
development of a new theory of the hippocampus, \emph{the hippocampus as
predictive map}.

\subsection*{Predictive hippocampus and successor representation}
\addcontentsline{toc}{subsection}{Predictive hippocampus and successor
representation}

The predictive vision of place cells may be summed up through the idea
in which \emph{place-cells} do not encode position of the animal per se,
but in terms of the future probable positions of the animal.

This vision is behaviorally and topologically dependent and thus
coherent with experimental finding and goal encoding capacity.
\cite{stachenfeld2017hippocampus} proposed a reinforcement learning
framework for this theory using the successor representation introduced
by Dayan \cite{dayan1993improving}.

The successor representation is know to be a tread-off between
model-based and model-free reinforcement learning: it encode a markovian
state in terms of the discounted probability of future reachable states.
In doing so, this representation makes it possible to convey topological
and behavioral similarities between the states. We will review this
claim in detail on the following sections.

\subsection*{Successor representation and limitations}
\addcontentsline{toc}{subsection}{Successor representation and
limitations}

In this paper we wanted to study the principles of algorithms using the
successor representation. First, we ask the question of realism: what
structure could we choose to approach a known neuro-cogntive system?
Then we study significance of their hyperparameters: the representation
successor depends on a ``gamma'' forgetting parameter that determines
the speed at which a relationship between two states becomes less
important. Finally we studied the form and properties of algorithms by
simultaneously using different forgetting parameters.

In section (\ref{RL}) we will introduce reinforcement learning with a
concise overview of methods for solving RL problems. Then in section
(\ref{SR}) we will study in detail the successor representation
formalization and as well as a variant method with multiple time-scale
properties called \emph{multi-scale SR}. In section (\ref{results}) we
will introduce our contribution Finally in section (\ref{discussion}) we
will discuss the extent of our results and the future work that could be
carried out.

\hypertarget{RL}{%
\section{Reinforcement learning introduction}\label{RL}}

According to \cite{sutton2011reinforcement} reinforcement learning aim
is ``to map situations to actions''. In other words, in reinforcement
learning (RL), an agent interact with an environment, this agent receive
a partial or perfect observation of the environment, this observation
allow it to create an internal representation or state of the
environment in return the agent act in term of this state or situation
changing in the process the current state of the environment; after its
action the agent receive a reward (good or bad) judging its previous
action. The RL goal is to maximize the good rewards over the lifetime of
the agent.

\subsection{Markov decision process}

\emph{Markov decision process} (MDP) is mathematical framework for
modeling sequential decision making, and thus a suitable instrument for
formally modelize RL problems. We will see that MDP can be written in a
\emph{Bellman equation} form, ensuring the existence of an optimal
\emph{policy of actions}.

\subsubsection{Finite Markov decision process}

A finite markov decision process is a tuple:
\[\mathcal{M} = (\mathcal{S}, \mathcal{A}(s), \mathcal{R}, P, R, \gamma, H)\]
Where \(\mathcal{S}\) is a set of states, \(\mathcal{A}(s)\) set of
actions in state \(s\), \(P\) the transition function, \(R\) the reward
function, \(\gamma\) the a discount parameter (\(\gamma \in [0, 1]\)),
\(H\) an horizon (\(H \in \mathbb{N} \cup \{\infty\}\)).

We define \(t\in \mathbb{N}\) the discrete time step at which the agent
interacts with the environment.

At each time step we have three random variables: the state
\(S_t \in \mathcal{S}\), the action taken \(A_t \in \mathcal{A}(s)\),
and the received reward \(R_{t+1} \in \mathcal{R}\).

By convention the reward is indexed by \(t+1\) and not \(t\) to emphasis
that \(R_{t+1}\) is a result from the action \(A_t\) taken in \(S_t\)
state. If \(H < \infty\), \(R_{t} = 0\) for \(t \geq H\). The Figure
\ref{} show the sketch the dynamic between these random variables.

\(P\) define the states dynamics or the state-transition probabilities
of the MDP: \begin{align}
  P \colon \mathcal{S} \times \mathcal{A} \times      \mathcal{S} &\to [0,1] \nonumber \\
  (s',a,s) &\mapsto P(s' | a, s) = \Pr\{S_{t+1}=s' | S_t=s, A_t=a\}
\end{align}

\(R\) the reward for each state-action pair: \begin{align}
  R \colon \mathcal{S} \times \mathcal{A} &\to [0,1] \nonumber \\
  (s,a) &\mapsto R(s, a) = R_{t+1}
\end{align}

Finally we define \(G_t\) the discounted reward from \(t\):
\begin{align}
  G_t &= \sum\limits_{k=t}^{\infty} \gamma^k R(S_{t+k}, A_{t+k}) \nonumber \\
        &= \sum\limits_{k=t}^{\infty} \gamma^k R_{t+k+1}
\end{align}

\subsubsection{Optimal control problem}

The objective of RL and optimal control problems in general is given a
MDP \(\mathcal{M}\), find the optimal policy \(\pi^{*}\) that
\emph{maximize} the expected discounted reward: \begin{align}
  \pi^{*} = \argmax_{\pi} \mathbb{E}_{\pi}[G_0]
\end{align} \(\pi\) define the agent policy as distribution over action:
\begin{align}
  A_t \sim \pi(S_t) &= \Pr\{A_t | S_t\} \nonumber \\
                    &= \pi(A_t | S_t)
\end{align}

\subsubsection{State-value and action-value functions}

Because the policy \(\pi^*\) maximize the reward of each infinite
sequence of rewards, it must in particular maximize \(G_t\) when the
state \(S_t\) or the state-action pair (\(S_t, A_t)\) is fixed. This
lead to the definition of the \emph{state-value function}: \begin{align}
  v^{\pi}(s) &= \mathbb{E}_{\pi}[G_t | S_t = s]
\end{align} and the \emph{action-value function}: \begin{align}
  Q^{\pi}(s,a) &= \mathbb{E}_{\pi}[G_t| S_t = s, A_t = a]
\end{align} These equations satisfy recursive relationships\footnote{The
  value and action-value functions are implicitly indexed by \(t\), this
  is the common notation.}: \begin{align}
v^{\pi}(s)  &= \mathbb{E}_{\pi}[G_t | S_t = s] \nonumber \\
            &= \mathbb{E}_{\pi}[R_t + \gamma G_{t+1}| S_{t+1} = s] \nonumber \\
            &= \sum\limits_{a \in \mathcal{A}(s)} \pi(a|s) \sum\limits_{s' \in \mathcal{S}} P(s' | s, a)[R(s,a) + \gamma\mathbb{E}_{\pi}[G_{t+1}| S_{t+1} = s']], \quad\forall s \in \mathcal{S}
\end{align} \begin{align}
  Q^{\pi}(s,a)  &= \mathbb{E}_{\pi}[G_t | S_t = s, A_t = a]\nonumber \\
                &= \mathbb{E}_{\pi}[R_t + \gamma G_{t+1}| S_{t+1} = s' , A_{t+1}= a' ] \nonumber \\
                &= \sum\limits_{s' \in \mathcal{S}} [R(s,a) + \sum\limits_{a' \in \mathcal{A}(s')} \gamma\mathbb{E}_{\pi}[G_{t+1}| S_{t+1} = s' , A_{t+1} = a']], \quad\forall (s,a) \in \mathcal{S} \times \mathcal{A}(s)
\end{align}

These functions lead to the \emph{Bellman equations} and thus a way to
find the optimal policy.

\subsubsection{Optimal value and action-value functions}

Finite MDPs allow one to easily define a way to find the optimal policy.
Indeed, if \(\mathcal{S}\) and \(\mahtcal{A}\) the number of behaviors,
or \(\pi\) policy is finite \((|\mathcal{S}|^{|\mathcal{A}|})\),
furthermore we can define a partial ordering on policy \(\pi\) such as
\(\pi' \geq \pi \Leftrightarrow v^{\pi'}(s) \geq v^{\pi}(s), \forall s \in \mathcal{S}\).
There is thus at least one optimal policy \(\pi*\). Optimal policy share
the same state-value function \(v^{\pi*}\) define as:

\begin{align}
  v^{\pi*}(s) = \max_{\pi} v^{\pi}(s), \quad\forall s \in \mathcal{S},
\end{align}

And the same action-value function \(q^{\pi*}\) define as: \begin{align}
  q^{\pi*}(s,a) = \max_{\pi} q^{\pi}(s,a), \quad\forall (s,a) \in \mathcal{S} \times \mathcal{A}(s)
\end{align}

Finally, because the optimal state-value and action-value satisfy the
\emph{Bellman equation}, we define the \emph{Bellman optimality
equation} for \(v^{\pi*}(s)\) as follow:

\begin{align}
  v^{\pi* }(s) &= \max_{a \in \mathcal{A}(s)} \mathbb{E}_{\pi* }[R_{t+1} + \gamma v^{\pi*}(S_{t+1})|S_t = s, A_t = a] \nonumber \\
                  &= \max_{a \in \mathcal{A}(s)} \sum\limits_{s' \in \mathcal{S}} P(s'|s,a)[r(s,a) + \gamma v^{\pi*}(s')]
\end{align}

The same goes for \(q^{\pi*}(s, a)\): \begin{align}
  q^{\pi* }(s,a) &=
  \mathbb{E}_{\pi*}[R_{t+1} +
  \gamma \max_{a' \in \mathcal{A}(S_{t+1})} q^{\pi*} (S_{t+1}, a')|S_t = s, A_t = a] \nonnumber \\
                  &= \sum\limits_{s' \in \mathcal{S}} P(s'|s,a)[R(s,a) + \gamma \max_{a' \in A} q^{\pi* }(s', a')]
\end{align}

Thus the optimal policy is the one where for each state \(s\) we compute
the best deterministic action a = \(\pi(s)\), or the best probability
vector \(\pi(.|s)\), regarding the next possible reward and then follow
the optimal policy for the rest of the sequence. In the next section we
will see that this formulation lead to a natural fixed-point algorithm.

\subsection{Approximation of states}

In the previous section we spoke about state per se, meaning that each
\(s \in \mathcal{S}\) is an alias for a precise configuration of the
environment. This is generally not a realistic description, because it
suppose a perfect and complete information of the environment state,
whereas animal, or robot are limited by their sensory abilities (i.e,
human cannot generally see behind them).

Moreover, even if it were possible to obtain a perfect view of the
environment, the number of states of most problems would be too huge to
be stored in memory. For example, according to \cite{mnih2015human},
which provide a deep-RL network for Atari games, a raw frame of an Atari
game is a \(210\) by \(160\) pixel image with \(128\)-color palette,
which accounts for a number of distinct states in the magnitude of
\(10^{512}\) elements.

For these two reasons we use approximation methods to compute state or
action value function. Each state \(s \in \mathcal{S}\) is associated
with a features vector \(\varphi(s) \in \mathbb{R}^{n}\), \(\varphi\) is
called a \emph{feature extraction method}. This extraction can consist
of a simple sensory readout, or a binary coding for presence or absence
of specific elements (i.e, a classifier), but generally the relevant
features are unknown and required a feature extraction process.

Unsupervised method like auto-encoder can be used for automatic features
extraction but feature engineering still require expert knowledge about
the raw data.

Finally, after extraction, we use an approximator
\(\hat{v}_{\theta}(s)\) or \(\hat(q)_{\theta}(s,a)\) parametrized by
\(\theta \ in \mathbb{R}^{d}\), where \(d << |\mathcal{S}|\).
\(\hat{v}_\theta\) and \(\hat{q}_\theta\) can be any desired
approximation function: linear regression, neural network, etc. All
following algorithms can be adapted with function approximation.

\subsection{Solving methods for MDPs}

In this section we present some known methods for solving MDPs.

\subsubsection{Dynamic programming and value iteration}

If the number of policy \(\pi\) is finite, the policy set can be
partially ordered, and the optimal Bellman equation formulation we can
easily implement with iterative process which from a given policy
\(\pi\) can construct a policy \(\pi'\) such as \(\pi' \geq \pi\). This
\emph{policy improvement} process as the following form: \begin{align}
  v^{\pi'}(s) &= \max_{a \in \mathcal{A}(s)} \mathbb{E}[R_{t+1} + \gamma v^{\pi}(S_{t+1}) | S_t = s, A_t = a], \forall s \in \mathcal{S} \nonumber \\
                &= \max_{a \in \mathcal{A}(s)} \sum\limits_{s' \in \mathcal{S}} P(s' | s,a)[R(s,a) + \gamma v^{\pi }(s')], \forall s \in \mathcal{S}
\end{align}

The DP algorithms converge to \(\pi*\) \cite{sutton2011reinforcement}
with a good convergence speed \cite{bonet2007speed}, but relies on
knowing the transition dynamics \(P\) (i.e, DP is a \emph{model-based}
solution). This requirement is generally impossible or very hard to
satisfy on non-trivial problems leading to model estimation or
model-free methods.

\subsubsection{Monte Carlo methods}

According to \cite{sutton2011reinforcement} Monte Carlo methods are
model-free algorithms with three principals advantages compare to DP:
they don't need to construct a model because they sample it, they don't
require to sample the entire model to be useful. (i.e, the set of
starting states can be a subset of \(\mathcal{S}\)). Monte Carlo draw
multiple samples state-action-reward triplet sequences called
\emph{episodes}:
(\(S_0, A_0, R_1, S_1, A_1, R_2,\dots,S_{H-1} A_{H-1},R_H\)), from an
arbitrary policy \(\pi\) and use them to estimate
\(q^{\pi}(s, a) \forall(s,a) \in \mathcal{S} \times \mathcal{A}(s)\).
The estimation of \(q^{\pi}(s,a)\) is given by the empiric average of
the discounted reward associated. Then the policy \(\pi\) is improved by
acting greedy with respect to the action-value estimation.

This simple version of Monte Carlo learning have some limitations:
because we learn \emph{on-policy} (i.e, we improve the policy \(\pi\)
use to make decision), the result is highly dependent on sampling and
can compute a sub-optimal policy.

A common solution is to learn \emph{off-policy} with a behavioral policy
\(b\) for generate episodes which is used to improve a second policy
\(\pi\). In order to have an estimation of \(\pi\) from \(b\), the two
policy must fulfill the \emph{assumption of coverage}:
\(\pi(s|a) > 0 \implies b(s|a) > 0\). For \(b\) a \(\epsilon\)-greedy
policy with respect to \(\pi\) is generally used. Because we sample
episodes in a different distribution than the one we want to improve we
need to use \emph{importance sampling} to make the result from \(b\)
relevant for \(\pi\) \cite{sutton2011reinforcement}.

\subsubsection{Temporal difference learning}

Temporal difference learning or TD learning is another model-free which
use \emph{bootstraping} meaning that TD learning update estimation of
state or action value on the basis of other estimates.

The idea of TD learning is to estimate \(v^{\pi}(S_t)\) by sampling a
\(n\)-lookup path from the MDP graph. For example \(0\)-lookup, or
TD(\(0\)) is equivalent to sampling \(R_t+1\) and \(v^{\pi}(S_{t+1})\):
\begin{align}
  v^{\pi}(S_t) = v^{\pi}(S_t) + \alpha[R_{t+1} + \gamma v^{\pi}(S_{t+1}) - v^{\pi}(S_t)]
\end{align} The other extreme case, TD(\(\infty\)) is equivalent to
sampling \(G_t\): \begin{align}
  v^{\pi}(v) = v^{\pi}(S_t) + \alpha[G_t - v^{\pi}(S_t)]
\end{align} The \(\infty\)-lookup is related to \emph{MC} method because
it sample and entire episode beginning by \(S_t\). Note that the
quantity \(R_{t+1} + \gamma v^{\pi}(S_{t+1}) - v^{\pi}(S_t)\) in
TD(\(0\)) is an error signal measuring the difference between the
estimate value of \(S_t\) and the sampled one. This error is called
\emph{error TD} and allow to measure how good the action leading to
\(S_{t+1}\) was, allowing in return to measure improvement of the action
policy at each time step. T(\(0\)) is thus usually preferred because it
don't rely on sampling episode, improve policy on-line and fit naturally
to non-stationary problem like autonomous car driving. Moreover, in
neuroscience, the \emph{error TD} is commonly used to model
\emph{dopamine reward prediction error}, a well establish theory of
learning by positive or negative reward signal resulting from the
difference between an experienced outcome and an expected one.
\cite{glimcher2011understanding}

See \ref{alg:q_learning} for a standard TD(\(0\)) algorithm for policy
improvement.

\subsubsection{Actor-Critic methods}

Actor-Critic (AC) split agent in two separate part interacting with each
other, an actor and a critic, the actor act with respect to the state
and the critic estimate and inform the actor about the quality of its
action.

AC models are generally considered intuitive, neurobiologically
realistic because they can be assimilated to dopamine-based
models\cite{khamassi2005actor} and efficient, for example
state-of-the-art implementation for Atari games solving is a AC
model\cite{mnih2016asynchronous}.

AC model combine two methods a value function estimator for the critic,
and a policy function estimator for the actor. For the value function,
the state-value function \(V^{\pi}_{\phi}\) is used with a TD(\(0\))
algorithm, this formulation allow to use the \emph{TD error} as quality
signal for the actor. The policy function is a new consideration, here
we try not to estimate \(\pi\) through the value functions, but to
optimize the policy directly.

\paragraph{Policy gradient methods}

Be \(\pi_{\theta}\) a policy parametrized by \(\theta\), we have the
following score function:

\begin{align}
J(\theta) &= \mathbb{E}_{\pi_{\theta}}[G_t]
\end{align} And we want to find \(\theta^*\) such as: \begin{align}
   \theta^* = \argmax_{\theta}  \bigtriangledown_{\theta} \mathbb{E}_{\pi_{\theta}}[G_t]
\end{align} The policy gradient can be written as follow\footnote{For
  the sake of brevity we use \emph{TD-error} as baseline and do not
  provide proof of derivation, see chap.13 of
  \cite{sutton2011reinforcement} for more details.}: \begin{align}
  \bigtriangledown J(\theta) = \mathbb{E}_{\pi_{\theta}}[\sum\limits_{t=0}^{\infty}(R_t + \gamma V(S_{t+1}) - V(S_t))\bigtriangledown_{\theta} \ln \pi(A_t|S_t)]
\end{align} The idea behind this formula is to use gradient ascent in
order to find a \(\theta\) parameter that will increase the probability
of path were the \emph{TD-error} is positive and vise-versa.

An example of AC algorithm can be fond here \ref{alg:AC}

\subsubsection{Model based method}

These methods estimate the state transition probability function, and
the reward probability function in order to do planning.

We already saw DP learning which use the true state transition dynamic
function to solve directly the \emph{Bellman equation}, another simple
model is \emph{Dyna-q} \cite{sutton2011reinforcement} that use standard
q-learning for sampling transitions and estimate the model, eventually
the algorithm will reuse the estimated model to improve its Q-value
function with replay.

Finally tree based algorithms like min-max tree or Monte Carlo tree
search use the model to plan a forward trajectory that maximize the
expected return.

\hypertarget{SR}{%
\section{Successor representation}\label{SR}}

\subsection{Motivation}

In the previous section we saw two main family for solving MDPs
problems: model free and model based methods. Model-based methods are
interesting because by knowing the model they can explore the MDPs
graph, thus even if the reward probability or the transition probability
change locally the information is visible to all the other state, this
is not the case for model free method because the estimation of value
function is always local.

However because model-free methods use local estimation, they does not
need to plan toward a terminal state or depth exploration limit like
model based algorithms, neither to store transition probability for each
node that could square the memory needed (i.e, complete graph have
\(n(n-1)\) transitions). Leading to describing model-free methods as
computationally cheaper.

Neurobiologically speaking we already saw that TD-learning is use to
model dopaminergic systems, another point of comparison is
model-free/model-based for habits/goal-directed comportment.
Goal-directed comportment are associated to planing, (i.e, what sequence
of actions I must take to go here?), whereas habits are inflexible
stimulus-response associations (i.e, reflex).

It has long been thought these two systems are not separate, thus an
important theory is the construction of habits behaviors are based on
multiples repetitions goal directed ones \cite{aarts2000habits}, or in
others words more one train to a new task, like car driving, less she
pay attention to low dimensional action like brakes, gear changes, etc.

Even if there is no generally accepted model for how this two systems
communicated, recent research suggest that the two systems are largely
overlapping, dopamine firing might reflect model-based processes
(\cite{doll2012ubiquity}, \cite{miller2019habits}).

As a trade-off between model-based and model-free, successor
representation (SR) could be a useful formalization for modeling theses
entangled systems.

\subsection{Formalization}

The original formulation of successor representations (SR)
\cite{dayan1993improving} is is a fairly old concept (1993), and subject
to a revival since a couple of years with the work of \emph{Gershman,
Samuel J.} and few others scientists \cite{gershman2012successor},
\cite{momennejad2012human}, \cite{stachenfeld2017hippocampus},
\cite{russek2017predictive}, \cite{gershman2018successor}.

The successor representation is based on re-writing the value functions
of a state or state-action pair in terms of a discounted probability
relation of reaching futures states or state-action pair.

Here we focus on the state-value function: \begin{align}
  v^{\pi}(s) = \sum\limits_{s' \in \mathcal{S}} M^{\pi}(s,s')\sum\limits_{a \in \mathcal{A}(s)}\pi(a|s')R(s',a)
\end{align}

\(M^{\pi}(s, s')\)
(\(M^{\pi} \in \mathcal{M}_{|\mathcal{S}|}(\mathbb{R})\)) represent the
time discounted probability that \(s'\) can be reach after \(s\). In
other words, states with a close temporal relation will have hight
\emph{SR} score and vice versa. Moreover \(M^{\pi}(s,s') = 0\) if they
is no \textbf{forward} path between \(s\) and \(s'\). \(M^{\pi}(s,s')\)
have the following notation: \begin{align}
  M^{\pi}(s_i, s_j) = \mathbb{E}_{\pi}[\sum\limits_{k=0}^{\infty} \gamma^{k}\mathbb{I}(S_{t+k} = s_j)| S_t = s_i],
\end{align} According to \cite{russek2017predictive} the state-value
function can be re-written as follow: \begin{align}
  V^{\pi}(s_i) = \sum\limits_{s_j \in \mathcal{S}} M^{\pi}(s_i, s_j) \, w(s_j)
\end{align} The \(w(s')\) is an estimation of
\(\sum\limits_{a \in \mathcal{A}(s)}\pi(a|s')R(s',a)\) that is
comparable to \emph{eligibility traces} in TD(\(\lambda\)). Following
the transition \(s \rightarrow s'\) we update the \(w\): \begin{align}
  \delta &= R(s_i,a) + \gamma_{td}v(s_j) - v(s_i) \nonumber \\
  w(i) &\leftarrow w(i) + \alpha_{td} \delta M^{\pi}(s_i, i), \quad\forall i \in \mathcal{S}
\end{align} The objective is then to find the best predictive
representation of state in terms of the reward function, thus unlike
model-based, the relation function between states is not absolute like
the transition probability function but behaviorally dependent.

SR method can also be written under \emph{Bellman equation}:
\begin{align}
  M^{\pi}(s_i, :) = \mathds{1}_{s_i} + \gamma\sum\limits_{s_j \in \mathcal{S}}T^{\pi}(s_i,s_j)M^{\pi}(s_i,:)
\end{align} \(M^{\pi}(s_i, :)\) is the SR-vector of \(s_i\) state,
\(T^{\pi}\) the one step transition matrix, and \(\mathds{1}_{s_i}\) the
one-hot encoding of \(s_i\).

\(M^{\pi}\) can be solved in two ways, one analytically by using
\(T^{\pi}\): \begin{align}
  M^{\pi}(s_i,:) = \sum\limits_{t=0}^{\infty} \gamma^{t}{T^{\pi}}^{t}(s_i,:) \nonumber \\
  M^{\pi} = (I - \gamma T^{\pi})^{-1}
\end{align} This method is called \emph{SR-MB} for \emph{SR}
model-based, because it presupposes that the transition matrix is known.

Another method use \emph{bootstraping} for updating \(M^{\pi}(s,:)\)
incrementally like TD learning: \begin{align}
  \delta = \mathds{1}_{s_i} + \gamma M^{\pi}(s_j,:) - M^{\pi}(s_i,:)
  M^{\pi}(s_i,:) \leftarrow M^{\pi}(s_i,:) + \alpha_{sr}\delta
\end{align} This method is called SR-TD for obvious reasons, here
\(\delta\) is the \emph{sensory prediction error} (\emph{SPE}) similar
to the TD \emph{RPE} \cite{gershman2012successor} it inform the agent if
an experienced transition is less or more probable than expected.

\subsection{Successor representation using features}

The \emph{SR} can also be written with features, be \(s_t\) a state,
\([f_{i}(s_t)]_{i=0}^{d}\) its feature representation, this successor
features (SF) encodes the expected feature values: \begin{align}
  M^{\pi}_{i}(s_t) = \mathbb{E}_{\pi}[\sum\limits_{k=0}^{\infty}\gamma^k f_{i}(s_{t+k})| s_t]
\end{align} The reward function is written as \(R(s) = w^{T}f(s)\)

Finally, we parametrized \(M^{\pi}\) by
\(w_{i,j} \in \mathcal{M}_{d}(\mathbb{R})\) a feature-by-feature weights
matrix: \begin{align}
  M^{\pi}_{i}(s_t) \approx w_{i,j}^{T} f(s_t)
\end{align} The weights matrix can be updated by \emph{bootstraping}:
\begin{align}
  \delta_{i} &= f_{i}(s_t) + \gamma M^{\pi}_{i}(s_{t+1}) - M^{\pi}_{i}(s_t) & \Delta w_{i,j} &= \delta_{i}f_{j}(s_t)
\end{align}

\subsection{Multi-scale SR}

SR matrix results highly depends on the discount parameter \(\gamma\) ,
this parameter can be interpreted as a time scale horizon, the rate at
which transitions distant in time are forgotten. In this section we will
see that combining multiple time horizon can provide valuable
information.

\subsubsection{Laplace transform}

According to \cite{Momennejad449470} writing \(M^{\pi}\) in terms of the
parameter \(\gamma\) leads to the formulation of a Laplace transform:
\begin{align}
  M^{\pi}(\gamma) &= \sum\limits_{t=0}^{\infty} \gamma^{t} {T^{\pi}}^{t} \nonumber \\
                  &\approx \int\limits_{0}^{\infty} \gamma^{t} {T^{\pi}}^{t} \nonumber \\
                  &\approx \int\limits_{0}^{\infty} e^{-\sigma t}{T^{\pi}}^{t} dt \nonumber & \sigma &= - \ln(\gamma)
\end{align} By determining the Laplace inverse transform \(L^{-1}\), a
transition matrix function in terms of time \(t\) can be obtain.
Considering two state (or feature) \(s_i\), \(s_j\) and
\(T^{t}(s_i, s_j) = \Pr\{S_t = s_j | S_0 = s_i\}\), \(T^{t}(s_i, s_j)\)
is maximal when \(t\) equals to the time/distance between \(s_i\) and
\(s_j\).

The true Laplace and inverse Laplace transform of this function are
of-course inaccessible, but \cite{Momennejad449470} and
\cite{shankar2013optimally} argue an approximation of these quantities
can be made by computing several \emph{SR} matrix with different
\(/gamma\) parameter.

An approximation of \(L^{-1}\) eventually came up using Post's inversion
formula. \cite{post1930generalized}.

In the next section we will call \(D(i,j) = \argmax_{t} T^{t}(i,j)\) for
each \((i,j) \in \mathcal{S} \times \mathcal{S}\), the distance matrix,
distance and time equivalent here, because the time step \(t\) at which
the \emph{MDP} evolve is constant.

\subsubsection{SR-TD distance learning}

Computing \(D\) offer a topological information between states,
information which allow us to ask interesting questions like what are
the spatial neighbors of state? does this neighborhood is changing? did
the agent getting closer to a goal? These questions will be empirically
explored in the next section, here let's focus only on how this approach
can be used to approximate \(v^{\pi}\).

One solution would be to use the inverse of the distance between two
states: \begin{align}
  v^{\pi}(s) \approx \sum\limits_{s' \in \mathcal{S}} \frac{1}{D(s,s')}w(s')
\end{align} Where \(w\) is still an estimation of the immediate reward.
But \(D(s,s') \in [0, +\infty]\) so \(\fact{1}{D(s,s')}\) could be
unbounded. To overcome such a limitation, we chose to compute for a
state \(s\) the inverse of the dense ranking of \(D(s,:)\).

The ranking function will for each \(D(s,:)\) provide a distance in
arbitrary step number. By definition \(D(s,s)\) will be associated to
\(1\), the closest neighbor will have the rank \(2\), the second closer
\(3\), and so on and so forth. The ranking function is choose dense
(i.e, \(Rank([0.1, 0.3, 0.2, 0.2]) = [1,3,2,2]\)) because we want states
at same distances receive same rank.

Finally, \(v^{\pi}\) is expressed as follow: \begin{align}
  v^{\pi}(s) &  \approx \sum\limits_{s' \in \mathcal{S}} \frac{1}{Rank(D(s,s'))}w(s') \nonumber \\
  w(i) &\leftarrow w(i) + \alpha_{td} \delta \frac{1}{Rank(D(s,i))}, \quad\forall i \in \mathcal{S}
\end{align}

\hypertarget{results}{%
\section{Results}\label{results}}

In this section we will present and comment different experimental
finding on the common and divergent points between \emph{SR-TD} and
\emph{SR-TD distance} methods, the motivations behind these experiments
are, how the algorithms handle change in transition and reward
probability functions? If \emph{SR-TD distance} method allow us to have
topological information can we use it for goal-directed planing? to
clustering the environment?

To carry out those comparisons we will rely on the work of recent work
on \emph{SR} like \cite{stachenfeld2017hippocampus},
\cite{russek2017predictive} and \cite{Momennejad449470}.

\subsection{SR-TD distance}

The first experiment Figure \ref{fig:linear_maze} demonstrate the
effectiveness of Laplace transform inverse operation, it show the
relation between (up) \(M^{\pi}\) in terms of \(\gamma\) and (down)
\(T^{t}\) in terms of \(t\). Each line \(i\_j\) correspond to (up)
\(M^{\pi}(i, j)\), (down) \(T^{t}(i,j)\).

The maze is it self a linear maze with \(8\) states (Figure
\ref{maze:linear}), for this experiment we allowed the agent to randomly
walk for \(10,000\) steps and record the the different \(SR\) matrices
and the distance matrix \(D\).

On the figure Figure \ref{fig:linear_maze} we observe that when the
agent is in the fist cell, other cells have a for \(T^{t}\) a different
maximal value. Whereas when the agent is at the second cell the maximal
value of the first cell is the same than the third one. These results
are coherent, because these two cells are at the same distance from the
second one.

\subsection{SR-TD distance and transition probability function}

\subsubsection{Previous works}

\cite{russek2017predictive}tested SR's efficiency in solving common
problems in cognitive sciences like food retrieval: The fist experiment
is the detour maze (fig link), this problem measure agent's ability to
cope with changes in the transition probability function.

This problem begin with a sampling episode where the agent start at the
\(S\) position, and randomly explore the maze without any reward during
\(10,000\) steps. We then add a reward of value \(10\) at \(R\)
position, agent complete \(20\) episodes to reward (from \(S\) to
\(R\)), finally we add a wall at \(w\) position and we place the agent
left from the wall (we note \(l\) this position). The agent sample
\(50\) times a one step transition from \(l\).

The results for \(M^{\pi}(l,:)\) are shown in Figure \ref{fig:wall_SR}
and Figure \ref{fig:wall_SR_distance} for \(D(l,:)\) vector.

The observation of \cite{russek2017predictive} are \emph{SR-TD} method
contrary to \emph{SR-MB} are not capable to infer a policy just by
sampling the new wall. (here policy means an increasing state-value
function from \(l\) to \(R\) without going toward the wall)

While it is still true for \emph{SR-TD distance} we can observe that
\emph{SR-TD} update the discounted probability of state \(17\) to be
equal to \(15\) whereas \emph{SR-TD distance} give for state \(17\) a
distance comparable to the state \(14\). Thus the former method give us
more relevant information in order to make a one step decision.

A limitation in \cite{russek2017predictive} is in the way the actions in
the maze are chosen, indeed for a state \(s\) the next action is
\(\epsilon\)-greedy determined with respect to the state-value of the
neighbor states. This imply to know that are the immediate future states
and this is generally not possible. For this reason and for the sake of
being as neurobiologically realistic as possible, we choose to use for
both \emph{SR-TD} and \emph{SR-TD distance} methods an actor-critic
model.

\subsubsection{Actor-critic results}

For this part we also use detour maze Figure \ref{maze:detour}, the
agent sample the maze for \(10,000\) times, a reward of value \(10\) at
\(R\) position is added, agent run \(20\) episodes from \(S\) to \(R\),
after the first \(20\) episode a wall at \(w\) is added added and agent
re-run \(20\) other episode. We record the number of step taken after
each episodes.

This experiments is solved with two actor-critic model one with
\emph{SR-TD} and one with \emph{SR-TD distance}. The two algorithms are
trained on their best hyperparameters found. The results are shown in
Figure \ref{fig:trans_SR} and Figure \ref{fig:trans_SR_distance}. Even
if \emph{SR-TD} converge toward the best path, because \(\gamma\) is
fixed and because we use \emph{bootstraping} the agent will take times
to take into account new unexpected transitions. \emph{SR-TD distance}
also suffer from \emph{bootstraping} but have better convergence
property because of the multiple time windows offer a better view of the
change in distance between state.

\subsection{SR-TD distance and reward function}

\subsubsection{Previous works}

In \cite{russek2017predictive} another experiment of food retrieval
consist of checking the ability of the agent to change its policy when a
better reward is encounter.

Amazingly, with \emph{SR} this behavioral change is possible just by
making the agent aware of the new reward position, indeed the
model-based structure of \emph{SR} can properly discount the reward
value in terms of the discounted probability of reaching each state.

By using \emph{SR-TD distance} method we hope to be able to mimic and
even outperform this property by using distance to state instead of
probability

\subsubsection{Actor-critic results}

We use for this experiments what we called the relearn maze Figure
\ref{maze:relearn}.

The experiment is the following: agent sample the maze \(10,000\) times,
a reward of value \(10\) is added at \(R1\) position, agent sample
\(R1\) reward \(30\) times then run \(20\) episodes ending when \(R1\)
is taken. Another reward of value \(100\) is added at \(R2\) position,
agent sample \(R2\) \(30\) times, then run \(20\) episodes ending when
\(R1\) or \(R2\) is token.

The results Figure \ref{fig:reward_SR} and Figure
\ref{fig:reward_SR_distance} show blue or orange dots, blue dot
correspond to and episode ending by the best reward available the orange
dot imply the opposite.

\emph{SR-TD distance} seems to learn faster than \emph{SR-TD}, and when
the reward is change the it is capable to learn to path to the new
reward \(5\) times more rapidly than \emph{SR-TD} method.

\subsection{SR-TD distance and clustering}

\subsubsection{Previous works}

The capacity of creating group of different states have an outstanding
value for both RL algorithms and cognition modeling in general, for
example separately the presence of a bed, a teddy bear and a pillow does
not have more meaning that the object itself but together it can express
the notion of \emph{bedroom}. Moreover the ability of create group leads
to the ability to create subgroup and thus hierarchical relation between
groups (i.e, a home is group of rooms, themselves group of objects).
This is equivalent to the idea of \emph{subgoal}, for example if I want
to go to my bedroom, I'd probably need to walk through the living room.
The living room is thus a \emph{sub-goal} of my goal. In fact
\emph{subgoal} discovery is what makes clustering capacity appealing for
sequential problem solving in general.

\cite{stachenfeld2017hippocampus} successfully describe a clustering
process of states using an approximation of a \emph{k-min-cut} algorithm
on \emph{SR} matrix. But this method seems, in our opinion, to suffer
from some limitations: first the results depends on the \(\gamma\)
parameters, \cite{stachenfeld2017hippocampus} claim that small value of
\(\gamma\) will produce short-term clustering, (i.e, states that are
very similar) and hight value will produce long-term clustering. This is
not so much a limitation but more an argument for computing multiples
\emph{SR}. Second the \emph{k-min-cut} clustering algorithm have as
hyperparameters the number of cluster wanted \emph{k} and rely on
spectral analysis and graph theory and thus does not simply be
neurobiologically interpreted.

To address these limitations, we will use a simple \emph{mean-shift}
clustering algorithm on the row of the \(D\) matrix. \emph{Mean-shift}
use a kernel density estimator in order to estimate attractor points
which will be considered as centroids of our clustering. Thus this
algorithm find by himself the number of cluster, and only the bandwidth
of the \emph{KDE} is needed.

The arguments for using this algorithm is primarily its simplicity, the
topological nature of \(D\), the relative neurobiologically
interpretation \emph{KDE} \cite{jakel2009does} and its ability to
interpret the bandwidth parameter as the desired granularity of
sub-goal.

We present few experiments of clustering with different maze, for each
of them we use a bandwidth estimator from \cite{scikit-learn}, this
algorithm use \(q \in [0,1]\), the quantile, as hyperparameter, this
method will compute the average max distance from each neighborhoods of
size \(q\) percent of the input data. The higher the quantile value is,
the larger the bandwidth size and the fewer clusters you get, the
quantile parameter is therefore well related to the granularity of
sub-goals.

\subsubsection{Maze with three rooms with SR-TD distance}

For the three rooms maze Figure \ref{maze:3_rooms} the agent randomly
explore the maze for \(10,000\) steps beginning from \(S\). We use the
clustering algorithm with \(q=0.2\), we hope to produce three cluster
one for each rooms. The three cluster shown on Figure \ref{fig:3_rooms}
are coherent with the input maze.

\subsubsection{Maze with five rooms with SR-TD distance}

We produce the same experiment with a more complex structure: Figure
\ref{maze:5_rooms}. The results Figure \ref{fig:5_rooms} does not
properly show the maze structure but still provide a coherent division
between rooms.

\subsubsection{Maze with russek's latent maze}

Finally we launch the same experiment with a far more complex maze from
\cite{russek2017predictive} Figure\textasciitilde{}\fig{maze:latent}.
The result from Figure \ref{fig:latent} does provide an interesting
division with a central structure, a upper structure and different color
for each dead end of the maze.

Finally, we provide a clustering of this maze with different values of
\(q\), we can observe the formation of increasingly large rooms with a
hierarchical relationship between them, the process goes on until it
reaches a single piece equal to the complete labyrinth. The results can
be seen at Figure \ref{fig:H_clustering}

\subsection{SR-TD distance and goal-directed behavior}

Here we will tried to answer to the question, how it is possible, with
model-based information to train an actor-critic model without reward?
One idea is to quantify whether the last agent's action has brought him
closer to his goal. For \emph{SR} matrix this means does the discounted
probability related to goal features from the new agent's state is
higher than the same quantity from the previous state.

For \(D\) matrix this means does the distance related to goal features
from the new agent's state is lower than the same quantity from the
previous state.

Concretely this means fixing the \(w\) vector to the wanted goal
features vector. And modify the \emph{TD error} signal as: \begin{align}
  \delta \leftarrow (M^{\pi}(S_{t+1}, :) - M^{\pi}(S_{s_{t}}))^{T}w
\end{align} for \emph{SR-TD} and: \begin{align}
  \delta \leftarrow (D(S_{t},:) - D(S_{t+1}))^{T}w
\end{align} for \emph{SR-TD distance}. We empirically test the capacity
of this new learning method with two experiment one with one goal and
with two successive goals.

\subsection{One goal experiment}

For this experiment we use the latent maze (Figure \ref{maze:latent}),
we set \(w\) to be a one-hot encoded representation of \(R2\), we then
as usual train an agent with \(10,000\) step of random walk, and record
\(100\) episodes to \(R1\) for \emph{SR-TD} method and \(20\) episodes
for \emph{SR-TD distance}.

The results for \emph{SR-TD} and \emph{SR-TD distance} can be seen at
Figure \ref{fig:one_goal_SR} and Figure \ref{fig:one_SR_distance}.

The two methods converge but the \emph{SR-TD distance} converge almost
instantly with a way lower first episode max-step value.

\subsection{Two goals experiment}

Even if the two methods converge, they maybe over-fit toward the goal
and may not be able to change their behavior when a new goal is given.

To check this capacity we choose to change the goal from \(R2\) to
\(R1\) after \(100\) and \(20\) episodes for \emph{SR-TD} and
\emph{SR-TD distance} method respectively, then records \(100\) and
\(20\) episodes for each.

The results for \emph{SR-TD distance} can be seen at Figure
\ref{fig:two_goal_SR_distance}.

We don't provide a figure for \emph{SR-TD} method because we were not
able to change its goal, contrary to \emph{SR-TD distance} method which
after one or two episodes converge directly to the new state.

\hypertarget{discussion}{%
\section{Discussion}\label{discussion}}

Recent experimental results on the Hippocampus spatial memory ability,
leads researcher towards a new paradigm for it, the hippocampus as
preceptive map. In this paper we studied the properties of mathematical
framework showing valuable properties to simulate this theory, the
successor representation. This representation allow to encode states in
terms of their future predictive positions, to construct an exponential
long term memory, and to represent state by a distance vector. We call
this last property \emph{multi-scale SR}. While being still immature
this theory of place-cells coding for a vector of distance is supported
by experiments in bats, rats and even human.

Our main contribution is to propose a simple, neurobiologically
interpretable actor-critic implementation for \emph{SR-TD} and
\emph{SR-TD distance} methods, and test the \emph{multi-scale SR}
framework on common and interesting cognitive problems for which it as,
to the best of our knowledge, never been tested before.

Our results empirically shown \emph{multi-scale SR} based methods can be
use for reinforcement learning and can take into account change in
transition probability and reward function. These new methods can even
outperform learning based one time scale like plain \emph{SR} methods.
We think, if the agent maintain enough exploration, the
\emph{multi-scale SR} methods maintain topological invariant for states
in the local environment of the agent (i.e, the states close to its
current policy).

This hypothesis is supported by the capacity of \emph{SR-TD distance},
contrary to \emph{SR}, to modelize goal-directed behaviors with
non-stationary goal. Moreover this method can also support the theory
whereby habits comes from repeated goal-directed behaviors. Indeed,
goal-directed behavior to a stationary goal without maintaining enough
exploration will gradually fit to an unique path towards the goal, the
distance information will only be relevant for the states in that path
leading to state-action relation, which is a definition of habits.

We shown the capacity of \emph{multi-scale SR} to cluster states with a
simple and neurobiologically compatible algorithm \emph{mean-shift}. The
bandwidth parameter for \emph{mean-shift} can be see as the wanted
granularity of the clustering process leading to the automatic discovery
of hierarchical clusters. In turn, these clusters could be seen as
abstract \emph{sub-goals} which the agent could manipulate to succeed in
his main objective. This idea is a central preoccupation of
\emph{hierarchical reinforcement learning} and for cognitive research
for spatial problems and sequential reasoning in general because
hierarchical thinking allow to encapsulate low-level spatial information
inside abstract labels like, home, kitchen, school, street, etc. and to
draw relation between them.

Our work was focus on gridworld and linear approximator function, the
natural next step will be to adapt and tests these method on complex
environment whether in a cognitive science perceptive with for example
3D food retrieval problems in \emph{Animal-AI olympics}
\cite{crosby2019animal} or for standard RL problems like Atari games.
From here one could also study the clustering capacity of
\emph{multi-scale SR} methods with more complex feature vectors.

Finally, another still unexplored area of research would be working to
provide a link between the \emph{SR} models and biologically more
realistic hippocampus models using spike neural networks like
\cite{gonner2017predictive}.

\appendix

\section{Maze layouts}

In verbatim until I write a good looking visualization.

\subsection{linear mazes}

\hypertarget{maze:linear}{%
\label{maze:linear}}%
\begin{verbatim}
+---+---+---+---+---+---+---+---+
| S                             |
+---+---+---+---+---+---+---+---+
\end{verbatim}

\subsection{Detour maze}

\hypertarget{maze:detour}{%
\label{maze:detour}}%
\begin{verbatim}
+---+---+---+---+---+---+
|                       |   
+   +---+---+---+---+   +   
|   |               |   |   
+   +---+---+---+---+   +---+
| S         w             R |
+   +---+---+---+---+   +---+
|   |               |   |   
+   +               +   +   
|   |               |   |   
+   +               +   +  
|   |               |   |
+   +---+---+---+---+   +
|                       |
+---+---+---+---+---+---+
\end{verbatim}

\subsection{Relearn maze}

\hypertarget{maze:relearn}{%
\label{maze:relearn}}%
\begin{verbatim}
+---+---+---+---+---+---+---+
|   |   |   |   |       | R1|
+---+   +---+   +---+   +   +
| S                 |   |   |
+---+   +---+   +---+   +   +
|   |   |   |   |       |   |
+   +   +   +   +---+---+   +
|   |   |   |               |
+   +   +   +   +---+---+   +
|   |   |   |   |       |   |
+---+   +   +   +   +   +   +
|       |   |   |       |   |
+   +   +   +   +   +   +   +
|   |   |   |   |       | R2|
+---+---+---+---+---+---+---+
\end{verbatim}

\subsection{Three rooms maze}

\hypertarget{maze:3_rooms}{%
\label{maze:3_rooms}}%
\begin{verbatim}
+---+---+---+---+---+
| S     |           |
+   +   +   +   +   +
|                   |
+   +   +   +   +   +
|       |           |
+---+---+---+---+   +
|                   |
+   +   +   +   +   +
|                   |
+   +   +   +   +   +
|                   |
+---+---+---+---+---+
\end{verbatim}

\subsection{Five Rooms maze}

\hypertarget{maze:5_rooms}{%
\label{maze:5_rooms}}%
\begin{verbatim}
+---+---+---+---+---+---+---+---+---+---+
| S                                     |
+   +   +   +   +   +   +   +   +   +   +
|                   |                   |
+   +   +   +---+---+---+---+   +   +   +
|           |                           |
+---+   +---+   +   +   +   +---+   +---+
|           |               |           |
+   +   +   +   +---+---+---+   +   +   +
|                                       |
+   +   +   +   +   +   +   +   +   +   +
|                   |                   |
+---+---+---+---+---+---+---+---+---+---+
\end{verbatim}

\subsection{Russek's latent maze}

\hypertarget{maze:latent}{%
\label{maze:latent}}%
\begin{verbatim}
+---+---+---+---+---+---+---+---+---+---+
|   |   |       |   |       |           |
+---+   +---+---+   +---+   +   +   +   +
| S                     |   |           |
+   +   +   +   +   +   +   +   +---+---+
|                       |   |   |       |
+---+   +---+---+   +---+   +   +   +   +
|   |   |       |   |       |   |       |
+   +   +   +   +   +---+---+   +   +   +
|   |   |       |               |       |
+   +   +   +---+   +   +   +   +   +   +
|   |   |   |                   |       |
+   +   +   +   +   +---+---+   +   +   +
|   |   |   |       |       |   |       |
+---+   +   +   +   +   +---+   +   +   +
|       |   |       |   |       |       |
+   +   +   +---+   +   +   +   +---+---+
|       |       |   |   |               |
+---+   +   +   +   +   +---+   +   +   +
|   |   |       |   |       |           |
+---+---+---+---+---+---+---+---+---+---+
\end{verbatim}

\section{Solving methods for MDPs}

\subsection{Dynamic programming}

This process have a simple form of dynamic programming where each state
\(V^{\pi}(s)\) is save inside a cell of an array.

\begin{algorithm}[H]
  \SetKwInOut{Input}{input}
  \SetKwInOut{Output}{output}
  \Input{The transition probability function: $P$}
  \Input{The reward function: $R$}
  \Input{The discount parameter: $\gamma$}
  \Input{Precision parameter: $\theta$}
  \Input{The action set: $\mathcal{A}$}
  \Input{The state set: $\mathcal{S}$}
  \KwResult{$\pi \approx \pi*$}
  \BlankLine
  \DontPrintSemicolon
  \SetAlgoLined
  Initialize array V from prior knowledge or by a 0-array\;
  \BlankLine
  \Repeat{$\Delta < \theta$}{
    $\Delta \gets 0$\;
    \ForEach{$s \in \mathcal{S}$}{
      $v \gets V(s)$\;
      $V(s) \gets \max_{a \in A(s)} \sum\limits_{s' \in \mathcal{S}} P(s'|s,a)[R(s,a) + \gamma v^{\pi }(s')]$\;
      $\Delta \gets \max(\Delta, |v - V(s)|)$ \;
    }
  }
  \BlankLine
  Output a deterministic policy, $\pi \approx \pi*$, such that\;
  $\pi(s) = \argmax_{a \in \mathcal{A}(s)} \sum\limits_{s' \in \mathcal{S}} P(s'|s,a)[R(s,a) + \gamma v^{\pi}(s')]$\;
\caption{Value iteration}
\label{alg:DP}
\end{algorithm}

\subsection{Q learning algorithms}

\begin{algorithm}[H]
  \SetKwInOut{Input}{input}
  \SetKwInOut{Output}{output}
  \Input{The discount parameter: $\gamma$}
  \Input{The average parameter: $\alpha$}
  \Input{The action set: $\mathcal{A}$}
  \Input{The state set: $\mathcal{S}$}
  \KwResult{$\pi \approx \pi*$}
  \BlankLine
  \DontPrintSemicolon
  \SetAlgoLined
  Initialize array Q from prior knowledge or by a $0$-array\;
  $Q(terminal-state, .) = 0$\;
  \BlankLine
  \ForEach{episodes}{
    Initialize first state $s \in \mathcal{S}$\;
    Initialize first action $a \in \mathcal{A}(s)$\;
    \ForEach{state in episode}{
      take action $a$, observe $r$, $s'$\;
      $\delta \gets r + \gamma \max_{a' \in \mathcal{A}} Q(s',a') - Q(s,a)$\;
      $Q(s,a) \gets Q(s,a) + \alpha \delta$\;
      $s \gets s'$\;
      $a \gets a'$\;
    }
  }
  \BlankLine
\label{alg:q_learning}
\caption{Q-learning}
\end{algorithm}

\begin{algorithm}[H]
  \SetKwInOut{Input}{input}
  \SetKwInOut{Output}{output}
  \Input{The action set: $\mathcal{A}$}
  \Input{The state set: $\mathcal{S}$}
  \Input{The discount parameter: $\gamma$}
  \KwResult{$\pi \approx \pi*$}
  \BlankLine
  \DontPrintSemicolon
  \SetAlgoLined
  Initialize array Q from prior knowledge or by a $0$-array\;
  Initialize $\theta$ the features vector\;
  $Q_{\theta}(terminal-state, .) = 0$\;
  \BlankLine
  \ForEach{episodes}{
    Initialize first state $s \in \mathcal{S}$\;
    Initialize first action $a \in \mathcal{A}(s)$\;
    \ForEach{state in episode}{
      take action $a$, observe $r$, $s'$\;
      $\delta \gets r + \gamma \max_{a' \in \mathcal{A}}
      \hat{Q}_{\theta}(s',a') - \hat{Q}_{\theta}(s,a)$\;
      $\theta \gets \theta + \alpha \delta \varphi(s, a)$\;
      $s \gets s'$\;
      $a \gets a'$\;
    }
  }
  \BlankLine
\label{alg:q_learning_approx}
\caption{Q-learning with function approximation}
\end{algorithm}

\subsection{Actor critic algorithms}

\begin{algorithm}[H]
  \SetKwInOut{Input}{input}
  \SetKwInOut{Output}{output}
  \Input{a differentiable policy: $\pi(a|s, \theta)$}
  \Input{a differentiable state-value: $v(s,w)$}
  \Input{The discount parameter: $\gamma$}
  \Input{Steps size $\alpha^{\theta}$, $\alpha^{w}$}
  \KwResult{$\pi \approx \pi*$}
  \BlankLine
  \DontPrintSemicolon
  \SetAlgoLined
  Initialize policy parameter $\theta \in \mathbb{R}^d$ and state-value weights $w \in \mathbb{R}^d$\;
  $V(terminal-state, w) = 0$\;
  \BlankLine
  \Repeat{$forever$}{
    Initialize $S$ the first state\;
    \While{$S$ is not terminal}{
      $A \sim \pi(.|S, \theta)$\;
      Take action A, observe S^', R\;
      $\delta \gets R + \gamma V(S^', w) - V(S, w)$\;
      $w \gets w + \alpha^{w}\delta\bigtriangledown_{w} V(S,w)$\;
      $\theta \gets \alpha^{\theta}\delta\bigtriangledown_{\theta} \ln \pi(A|S, \theta)$\;
      $S \gets S^'\;
    }
  }
  \BlankLine
\label{alg:AC}
\caption{Actor critic algorithm from \cite{sutton2011reinforcement}}
\end{algorithm}

The AC algorithms of \emph{SR-TD} and \emph{SR-TD distance} replace
\(\bigtriangledown_{w} V(S,w)\) by \(M^{\pi}(S,:)\) and \(D(S, :)\)
respectively. The policy function is parametrized by a simple feature to
action matrix, called \(U\)
(\(U \in \mathbb{R}^{|\mathcal{A}(s)| \times |\varphi(S_t)|}\)), the
action is sampled from \(\pi(.|S_t) = softmax(U\varphi(S_t))\). The
policy gradient \(\bigtriangledown_{\theta} \ln \pi(A|S, \theta)\) is
simply \(\varphi(S_t)\).

\begin{figure}[H]
  \caption{Markov decision process}
  \centering
    \includegraphics[width=.5\textwidth]{../img/MDP.pdf}
    \label{fig:MDP}
\end{figure}
\begin{figure}[H]
  \caption{Linear maze with eight states, here only state one and two are show}
  \centering
    \includegraphics[width=.9\textwidth]{../img/linear_maze_0_maze.pdf}
    \includegraphics[width=.9\textwidth]{../img/linear_maze_1_maze.pdf}
    \label{fig:linear_maze}
\end{figure}

\begin{figure}[H]
  \caption{Discounted probability change while sampling a new wall}
  \centering
    \includegraphics[width=1.\textwidth]{../img/SR_wall_sampling.pdf}
        \label{fig:wall_SR}
\end{figure}

\begin{figure}[H]
  \caption{Discounted probability change while sampling a new wall}
  \centering
    \includegraphics[width=1.\textwidth]{../img/SR_distance_wall_sampling.pdf}
    \label{fig:wall_SR_distance}
\end{figure}

\begin{figure}[H]
  \caption{Change in transition probability function with SR-TD method}
  \centering
    \includegraphics[width=1.\textwidth]{../img/Detour_tolman_maze_SR-AC.pdf}
    \label{fig:trans_SR}
\end{figure}

\begin{figure}[H]
  \caption{Change in transition probability function with SR-TD distance method}
  \centering
    \includegraphics[width=1.\textwidth]{../img/Detour_tolman_maze_with_100_SR-windows.pdf}
    \label{fig:trans_SR_distance}
\end{figure}

\begin{figure}[H]
  \caption{Change in reward function with SR-TD method}
  \centering
    \includegraphics[width=1.\textwidth]{../img/simple_Relearn_tolman_maze_SR-TD_AC.pdf}
    \label{fig:reward_SR}
\end{figure}

\begin{figure}[H]
  \caption{Change in reward function with SR-TD distance method}
  \centering
    \includegraphics[width=1.\textwidth]{../img/simple_Relearn_tolman_maze_SR-distance.pdf}
    \label{fig:reward_SR_distance}
\end{figure}

\begin{figure}[H]
  \caption{Goal-directed behavior with SR-TD method, one goal}
  \centering
    \includegraphics[width=1.\textwidth]{../img/Goal_directed_SR_one_goal.pdf}
    \label{fig:one_goal_SR}
\end{figure}

\begin{figure}[H]
  \caption{Goal-directed behavior with SR-TD distance method, one goal}
  \centering
    \includegraphics[width=1.\textwidth]{../img/Goal_directed_SR_distance_one_goal.pdf}
    \label{fig:one_SR_distance}
\end{figure}

\begin{figure}[H]
  \caption{Goal-directed behavior with SR-TD distance method, two goal}
  \centering
    \includegraphics[width=1.\textwidth]{../img/Goal_directed_SR_distance_two_goal.pdf}
    \label{fig:two_goal_SR_distance}
\end{figure}

\begin{figure}[H]
  \caption{Three rooms clustering }
  \centering
    \includegraphics[width=1.\textwidth]{../img/clusterin_3_rooms_0.pdf}
    \label{fig:3_rooms}
\end{figure}

\begin{figure}[H]
  \caption{Five rooms clustering}
  \centering
    \includegraphics[width=1.\textwidth]{../img/clusterin_5_rooms_2.pdf}
    \label{fig:5_rooms}
\end{figure}

\begin{figure}[H]
  \caption{Russek's latent maze clustering}
  \centering
    \includegraphics[width=1.\textwidth]{../img/clustering_latent_russek_0.pdf}
    \label{fig:latent}
\end{figure}

\begin{figure}[H]
  \caption{Russek's latent maze hierarchical clustering}
  \centering
    \includegraphics[width=.9\textwidth]{../img/clustering_latent_russek_0_10.pdf}
    \includegraphics[width=.9\textwidth]{../img/clustering_latent_russek_0_15.pdf}
    \includegraphics[width=.9\textwidth]{../img/clustering_latent_russek_0_20.pdf}
    \includegraphics[width=.9\textwidth]{../img/clustering_latent_russek_0_25.pdf}
    \label{fig:H_clustering}
\end{figure}
\begin{figure}[H]
  \caption{Russek's latent maze hierarchical clustering}
  \centering
    \includegraphics[width=.9\textwidth]{../img/clustering_latent_russek_0_30.pdf}
    \includegraphics[width=.9\textwidth]{../img/clustering_latent_russek_0_35.pdf}
    \includegraphics[width=.9\textwidth]{../img/clustering_latent_russek_0_40.pdf}
    \label{fig:H_clustering}
\end{figure}

\medskip

\bibliographystyle{splncs04}
\bibliography{../bib/papers}
%
\end{document}
